import numpy as np
import urllib.request
import random

def getName():
    result = str(urllib.request.urlopen("https://www.behindthename.com/random/random.php?number=1&surname=&norare=yes&nodiminutives=yes&all=no&usage_eng=1&usage_rus=1").read()) #get the html text from website
    position = result.find('name/')+5   #find the name in the soup of html text
    name = ''
    while (result[position].isalpha()): #get all letters in name
        name += result[position]
        position += 1
    return name.capitalize()

def initZombies(N):
    zombyNameTranscription = []                                                             #init array of names
    for i in range(N):
        zombyNameTranscription.append(getName())                                            #fill the a array with names
    zombyNames = np.fromfunction(lambda i,j: i, (N, 1), dtype=int)                          #the column of names (from 0 to N) in main matrix
    zombyLifeData = np.random.randint(50, 70, (N, 2))                                       #creates the columns of health, food parameters
    zombyParameters = np.random.randint(0, 50, (N, 3))                                      #creates the columns of depression, intellegence, agility
    zombyIndicator = np.ones(N)                                                             #creates the column of zombie indecator (0 - zombie, 1 - survivor)
    zombyParameters = np.c_[zombyLifeData, zombyParameters, zombyIndicator, zombyNames]     #gather all columns in one data matrix
    return zombyParameters, zombyNameTranscription

def getValue(x):
    if (x<0):           #the value should be 0 or bigger
        return 0
    elif (x>100):       #the value should be 100 or less
        return 100
    return round(x)     

def changesurvivorParameters(survivor, action):    
    if (survivor[0][0]<20 or survivor[0][1]==0):                        #change the survivors into zombies if they are dying
        survivor[0][5] = 0
        return 0,0
    else:
        if (action == "food"):
            newFood = .01*survivor[0][1]*np.sum(survivor[:,-4:5])/2     #increase the food accrodying to the agility and IQ
            survivor[0][1]  = getValue(survivor[0][1] + newFood)            
            newHealth = survivor[0][0]*.01*survivor[0][2]               #decrease the Health, because the food day accrodying to the depression
            survivor[0][0] = getValue(survivor[0][0] - newHealth)
            survivor[0][2] = getValue(survivor[0][2] + 10)              #increase the depression

            return newHealth, newFood
        
        elif (action == "medicine"):
            newHealth = .01*survivor[0][0]*np.sum(survivor[:,-4:5])/2   #increase the health accrodying to the agility and IQ
            survivor[0][0]  = getValue(survivor[0][0] + newHealth)
            
            newFood = survivor[0][1]*.01*survivor[0][2]                 #decrease the food accrodying to the agility and IQ
            survivor[0][1] = getValue(survivor[0][1] - newFood)

            survivor[0][2] = getValue(survivor[0][2] + 10)              #increase the depression
            
            return newHealth, newFood
        elif (action == "rest"):
            survivor[0][2] = getValue(survivor[0][2] - 20)              #decrese the depression
            return 0 , 0

def OneDayCalculates(data, events):

    dice = np.random.randint(1,7)                                       #roll a dice to determine lucky or bad day
    if (dice == 1):
        print("Bad day! All characters health will decrease by 2 :(")
        data[:,0] -= 2                                                  #all players lose 2 health
    if (dice == 6):
        print("Hooray! Lucky day. All players gain 2 health")
        data[:,0] += 2                                                  #all players gain 2 more health

    healthByDay = 0
    foodByDay = 0
    action = random.choice(events)
    for i in range(np.shape(data)[0]):
         health , food = changesurvivorParameters(data[i:i+1], action)         
         healthByDay += health
         foodByDay += food
         if (np.sum(data[:, [-2]])==0):
             print("**********************************************************************************************")
             print("**********************************WELCOME TO ZOMBIE'S LAND!!!**********************************")
             print("**********************************************************************************************")
             exit(1)
    return healthByDay, foodByDay         

         #Report all of the statistics back to the user
def statistic(data, i, numberofDays, numberofZombies, names, healthByDay , foodByDay):
    print("*********************day number " + str(i)+" *********************")
    print(str(np.sum(data[:, [-2]])) + " people of " + str(numberofZombies) + " are still alive\n")
    print("Name".ljust(20)+"Health / Food")
    print("----".ljust(20)+"-------------")
    for i in range(1,numberofZombies):
        if (data[i][5]==1):
            print(str(names[i]).ljust(20)+str(data[i][0])+" / "+str(data[i][1]))
    print("----------------------------------------")        
    print("total health change during the day = " + str(healthByDay))
    print("total food change during the day = " + str(foodByDay))
    
    print("\n\n")
    
def main():
    numberofZombies = 25
    numberofDays = 15
    events = ["food", "medicine", "rest"]
    data, names = initZombies(numberofZombies)
    print(data)
    for i in range(numberofDays):
        healthByDay , foodByDay = OneDayCalculates(data, events)
        statistic(data, i, numberofDays, numberofZombies, names , healthByDay , foodByDay)

if __name__ == "__main__":
    main()
